import { __awaiter, __generator } from "tslib";
import { env } from "@azure/test-utils-recorder";
import { retry as realRetry } from "./retry";
import { isNode } from "@azure/core-http";
import * as dotenv from "dotenv";
import * as path from "path";
if (isNode) {
    dotenv.config({ path: path.resolve(__dirname, "../../../.env") });
}
export var isRecording = env.TEST_MODE === "record";
export var isPlayingBack = env.TEST_MODE === "playback";
export function retry(target, delay, timeout, increaseFactor) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, realRetry(target, isPlayingBack ? 0 : delay || 10000, timeout || Infinity, increaseFactor)];
        });
    });
}
export function uniqueString() {
    return isPlayingBack
        ? ""
        : Math.random()
            .toString()
            .slice(2);
}
export var testPollerProperties = {
    intervalInMs: isPlayingBack ? 0 : undefined
};
//# sourceMappingURL=recorderUtils.js.map